#ifndef __CBissCard_H__
#define __CBissCard_H__
#include <Windows.h>
#include <Rtapi.h>
union __PACKET {
	struct {
		ULONG low;
		ULONG high;
	}a;

	struct {
		unsigned int data : 32;//
							   //unsigned int r0 : 6;//Ԥ
		unsigned int div : 16;//ʱ
		unsigned int r1 : 5;//Ԥ
		unsigned int crcv : 6;//crcvУ
		unsigned int err : 1;//λ
		unsigned int war : 1;//λ
		unsigned int chn : 3;//ͨλ
	}b;
};

// Total number of cards allowed for the test
#define MAX_NUM_CARDS
#define REGISTER_OFFSET 0
#define ENDAT2_2 0x02
#define ENDAT2_1 0x03
#define SSI	  0x01
#define BISS_C 0x00
#define PCIE_2011_CLOCK_10M 0x01
#define PCIE_2011_CLOCK_4M 0x03
#define PCIE_2011_CLOCK_2M 0x04
#define PCIE_2011_CLOCK_1M 0x05
#define PCIE_2011_CLOCK_500K 0x06
/*ʹòΪ
ʼʱ
1.豸...2.ʼ豸...3.豸...4.ʼ
ʱУ
1.DMA_TransmissionEndݴ...2.Snc_CollectBiss
3.ͨGetCurrentLocationGetCurrentSpeedõǰλüٶȣֱӴԭm_ppsBissInfo...
*/
class CBissCard
{
public:
	ULONG  m_dwBusNum;                            // Bus number
	DWORD  m_dwDeviceNum;                         //Device number
	DWORD  m_dwFunctionNum;                       // Function number
	DWORD  m_dwCardNum;                           // Card number, 0-based

	PCI_SLOT_NUMBER SlotNumber;
	ULONG	m_clock_freq;
	ULONG	m_protocol;
	ULONG   m_clock_bit[5];
	LARGE_INTEGER m_memAddr[3];
	__PACKET m_snrdat;
	__PACKET m_sBissInfo[5];
	__PACKET m_sPreBissInfo[5];
	__PACKET m_sPrePreBissInfo[5];
	__PACKET**	m_ppsBissInfo;
	PULONG  m_pdwPhyMemory;            //Physics Memory
	LARGE_INTEGER m_llMemoryAddr;     //Physics Memory Address
	PUCHAR vMemAddr[3];
	PPCI_COMMON_CONFIG  PciData;
	UCHAR   buffer[PCI_COMMON_HDR_LENGTH];                      //PCI Header
	int	m_iDataGroupNum;
public:
	CBissCard();//ĬBISS_CЭ飬ʱ2Mͨ26λ
	~CBissCard();

	//SearchDeviceBissPci忨豸ߺţδ-1ʹʾ£ʵ࣬Ϊm_BissCardͬ
	//m_dwCardNumڹ캯ĬϸֵΪ0ʹö忨ڵøúǰ˳ֵñڶŰ忨ǰm_BissCard_2.m_dwCardNum = 1;
	/*
	if ((m_BissCard.m_dwBusNum = m_BissCard.SearchDeviceBiss(m_BissCard.m_dwCardNum,&m_BissCard.SlotNumber,m_BissCard.PciData))==-1)
	{//not found
	RtPrintf("WARNING: No BISS card was found in this machine.\n");
	ExitProcess(0);
	}
	else
	{
	RtPrintf("BISS card was found in this machine.\n");
	}
	*/
	int     SearchDeviceBiss(int nCardNumber, PCI_SLOT_NUMBER *pSlotNumber, PPCI_COMMON_CONFIG  PciData);
	//InitDeviceBissʼָ忨,ɹtrueʧܷfalseʹʾ
	/*
	if(!(m_BissCard.InitDeviceBiss(m_BissCard.PciData, &m_BissCard.SlotNumber,m_BissCard.m_dwBusNum)))
	{
	RtPrintf("WARNING: BISS Card Configuration failed!\n");
	ExitProcess(0);
	}
	else
	{
	RtPrintf("BISS Card Configuration OK!\n");
	}
	*/
	bool     InitDeviceBiss(PPCI_COMMON_CONFIG PciData, PCI_SLOT_NUMBER *pSlotNumber, int nBusNum);
	//SetPcieClockð忨ʱƵʣ PCIE_2011_CLOCK_10MPCIE_2011_CLOCK_4MPCIE_2011_CLOCK_2MPCIE_2011_CLOCK_1MPCIE_2011_CLOCK_500K
	void	SetPcieClock(ULONG clock);
	//SetProtocolð忨Э飬ENDAT2_1 ENDAT2_2 SSI BISS_C
	void	SetProtocol(ULONG prot);
	//SetChannelBitöӦͨλʱӸChnͨţ0~4,bitcountλɹtrueʧܷfalse
	bool	SetChannelBit(int Chn, unsigned long bitcount);
	//ConfigDeviceBissð忨1-1ʾRtxڴӳʧܣ-2ʾڴַλ쳣
	int		ConfigDeviceBiss();
	//Snc_CollectBiss忨Ĵдʼ
	void    Snc_CollectBiss();
	//DMA_TransmissionEndDMA,ȡԭʼݣԭʼݱm_ppsBissInfo[i][j]άУiΪţ0Ϊ£jΪͨ,1쳣0
	int		DMA_TransmissionEnd();
	//CleanupDeviceBissͷŰ忨Դ˳ʱ
	void	CleanupDeviceBiss();
	//SetDataGroupNumĬΪ1
	void	SetDataGroupNum(int iDataGroupNum);
	//GetCurrentSpeedȡiChannelNum(0~4)ͨٶȣǶȷء/sֱ߷mm/sSetDataGroupNum2bIsNeedEWcheckǷҪErrWarжϣBISS_CãSSIһ㲻ã
	//bIsAngleñǷΪǶȱǶtrueֱfalsedLineResʾֱ߹դֱʣǶȹդʱֱֵ߹դʱֱ(um/ֵ)
	//ʱ1bIsNeedEWcheckΪtrueʱcheckʧܷ0m_iDataGroupNum-1ͨλ쳣-2
	int		GetCurrentSpeed(double& dCurSpeed, int iChannelNum, bool bIsNeedEWcheck, bool bIsAngle, double dLineRes);
	//GetCurrentLocationiChannelNumͨǰλ,Ƕȷء㣬ֱ߷mmGetCurrentSpeedͬ	
	//λ쳣-2bIsNeedEWcheckΪtrueʱֵͨm_ppsBissInfo[i][j]еiоδͨ-1
	//bIsNeedEWcheckΪfalseʱֵΪ0dCurLocationΪ(0)
	int		GetCurrentLocation(double& dCurLocation, int iChannelNum, bool bIsNeedEWcheck, bool bIsAngle, double dLineRes);
};

#endif
