#ifndef __CBissCard_H__
#define __CBissCard_H__
#include <Windows.h>
#include <rtapi.h>
union __PACKET{
	struct  {
		ULONG low;
		ULONG high;
	}a;

	struct {
		unsigned int data :26;
		unsigned int r0:6;
		unsigned int div:16;
		unsigned int r1:5;
		unsigned int crcv: 6;
		unsigned int err: 1;
		unsigned int war: 1;
		unsigned int chn: 3;
	}b;
};

// Total number of cards allowed for the test
#define MAX_NUM_CARDS
#define REGISTER_OFFSET 0


class CBissCard
{
public:
	ULONG  m_dwBusNum;                            // Bus number
	DWORD  m_dwDeviceNum;                         //Device number
	DWORD  m_dwFunctionNum;                       // Function number
	DWORD  m_dwCardNum;                           // Card number, 0-based

	PCI_SLOT_NUMBER SlotNumber;


	__PACKET m_snrdat;
	__PACKET m_sBissInfo[5];
	__PACKET m_sPreBissInfo[5];
	__PACKET m_sPrePreBissInfo[5];
	__PACKET**	m_ppsBissInfo;
	PULONG  m_pdwPhyMemory;            //Physics Memory
	LARGE_INTEGER m_llMemoryAddr;     //Physics Memory Address
	PCHAR vMemAddr[3];
	PPCI_COMMON_CONFIG  PciData ; 
	UCHAR   buffer[PCI_COMMON_HDR_LENGTH];                      //PCI Header
	int	m_iDataGroupNum;
public:
	CBissCard();
	~CBissCard();
	int     SearchDeviceBiss(int nCardNumber, PCI_SLOT_NUMBER *pSlotNumber, PPCI_COMMON_CONFIG  PciData);
	int     InitDeviceBiss(PPCI_COMMON_CONFIG PciData,PCI_SLOT_NUMBER *pSlotNumber, int nBusNum);
	void	ConfigDeviceBiss();
	BOOL    Snc_CollectBiss();//(int nChannal,double dInterval,double dData,int ResmErr,int ResmWarning);
	void	DAM_TransmissionEnd();
	void	CleanupDeviceBiss();
	void	SetDataGroupNum(int iDataGroupNum);
};

#endif
